## Agenda for practicals

For the convenience of students, I will try to update this page with lists of some of the topics we covered in each practical (but see also the pdf files in [this directory](https://gitlab.com/universalalgebra/nmag405/-/tree/master/notes), which contain notes and scratch work from the practical discussion).

-------------------------

### 12. Jan 7

**Lecture**.  Mal'cev conditions: Mal'cev, majority. Mal'cev conditions [(notes)](https://www2.karlin.mff.cuni.cz/~barto/UA/UA_Lecture_Notes_12.pdf)  
**Practical**. Majority implies CD [(notes)](https://gitlab.com/universalalgebra/charlesuniversity/nmag405/-/blob/master/notes/practical/NMAG405Practical12.pdf)

--------------------------

### 11. Dec 17

**Lecture**. *Galois correspondence* between operations and relations [(notes)](https://www2.karlin.mff.cuni.cz/~barto/UA/UA_Lecture_Notes_11.pdf)  
**Practical**. Algebraic and relational clones [(notes)](https://gitlab.com/universalalgebra/charlesuniversity/nmag405/-/blob/master/notes/practical/NMAG405Practical11.pdf)

------------------------------------

### 10. Dec 10

**Lecture***. *Clones*; *Free algebras* as clones of term operations [(notes)](https://www2.karlin.mff.cuni.cz/~barto/UA/UA_Lecture_Notes_10.pdf)  
**Practical**. *Clones* [(notes)](https://gitlab.com/universalalgebra/charlesuniversity/nmag405/-/blob/master/notes/practical/NMAG405Practical10.pdf)

------------------------------------

### 9. Dec 3

**Lecture**. *Galois correspondence* between syntax and semantics; *Birkhoff's theorem* [(notes)](https://www2.karlin.mff.cuni.cz/~barto/UA/UA_Lecture_Notes_09.pdf)  
**Practical**. *Equational bases* and how to find them [(notes)](https://gitlab.com/universalalgebra/charlesuniversity/nmag405/-/blob/master/notes/practical/NMAG405Practical09.pdf)

--------------------------------------

### 8. Nov 26

**Lecture**. Terms, identities, free algebras [(notes)](https://www2.karlin.mff.cuni.cz/~barto/UA/UA_Lecture_Notes_08.pdf)  
**Practical**. Free algebras [(notes)](https://gitlab.com/universalalgebra/charlesuniversity/nmag405/-/blob/master/notes/practical/NMAG405Practical08.pdf)

--------------------------------------

### 7. Nov 19

**Lecture**. Subdirect decomoposition, SIs in congruence distributive vaieties [(notes)](https://www2.karlin.mff.cuni.cz/~barto/UA/UA_Lecture_Notes_07.pdf)   
**Practical**. Case study: SIs in monounary algebras [(notes)](https://gitlab.com/universalalgebra/charlesuniversity/nmag405/-/blob/master/notes/practical/NMAG405Practical07.pdf)

--------------------------------------

### 6. Nov 12

**Lecture**. Direct and subdirect decomposition [(notes)](https://www2.karlin.mff.cuni.cz/~barto/UA/UA_Lecture_Notes_06.pdf)  
**Practical**. Direct and subdirect decomposition [(notes)](https://gitlab.com/universalalgebra/charlesuniversity/nmag405/-/blob/master/notes/practical/NMAG405Practical06.pdf)

--------------------------------------

### 5. Nov 5 

**Lecture**. H,S,P operators, variety. Homomorphisms [(notes)](https://www2.karlin.mff.cuni.cz/~barto/UA/UA_Lecture_Notes_05.pdf)  
**Practical**. Homomorphisms. Finite algebras generate locally finite varieties [(notes)](https://gitlab.com/universalalgebra/charlesuniversity/nmag405/-/blob/master/notes/practical/NMAG405Practical05.pdf)

--------------------------------------

### 4. Oct 29 

1. **Subuniverses**
   + For 𝑨 = (𝐴, *) with an operation given by a table, find all subuniverses and draw Sub(𝑨).

2. **Subpowers**
   + Show that every binary relation is a subpower of ({0,1}, majority).
   + Find some ternary relation which is not a subpower.

3. **Congruences**
   + For 𝑨 = (𝐴, *) with an operation given by a table, find all congruences and draw Con(𝑨).
   + The join of two congruences α, β = the directed union of (α ∘ β ∘ α ∘ ⋯ ) = the join α ∨ β as equivalences.  

   (For the first item, first prove it's enough to check a θ b => ac θ bc and ca θ cb, because then congruences are easy to generate from the table. Maybe start with a monounary algebra, and then do binary.)

4. (time permitting)
   + find congruences for some lattices (eg. 𝑁₅, 𝑀₃) and observe structure of congruence blocks.
   + more exercises e.g. in David's exercise book eg. for generating subuniverses
     - find a 3-element generating set of (ℤ, +). Prove that no 2-element exists
     - prove that (ℕ, +)² is not finitely generated
     - prove that (𝑴₂(ℤ); +, -, ·) (2 × 2 integer matices) is generated by the two matrices ((11),(01)) and ((10),(11))

(N.B. The correspondence "normal subgroups ⇔ congruences" is in the homework.)

Ref: Bergman 1.3, 1.4, 1.5  
[Lecture notes](https://www2.karlin.mff.cuni.cz/~barto/UA/UA_Lecture_Notes_04.pdf), 
[practical notes](https://gitlab.com/universalalgebra/charlesuniversity/nmag405/-/blob/master/notes/practical/NMAG405Practical04.pdf)

-----------------------------------------------------------

### 3. Oct 22 

1. **Subniverses, subalgebras and the Birkhoff-Frink Theorem** (Thm 2.33 in Bergman)

2. **Galois connections** between unary relations and operations (Example 2.36.(5) from Bergman)

3. **Closure operators and Galois correspondences** (come up with the relation that works)

4. **Exercise Set 2.34 in Bergman** (but not Problem 1, which is homework)

5. **Questions**

   + Find a complete lattice with a sublattice that is not complete
   + Find an incomplete lattice with a sublattice that is complete
   + Find a complete lattice with a sublattice that is complete but is not a complete sublattice.

6. (time permitting) Prove the following theorem from lecture:

   **Theorem**. Every algebraic complete lattice is isomorphic to 𝑳<sub>𝐶</sub> for some algebraic closure operator 𝐶.

Ref: Bergman 2.4, 2.5  
[lecture notes](https://www2.karlin.mff.cuni.cz/~barto/UA/UA_Lecture_Notes_03.pdf), 
[practical notes](https://gitlab.com/universalalgebra/charlesuniversity/nmag405/-/blob/master/notes/practical/NMAG405Practical03.pdf)

---------------------------------

### 2. Oct 15

1. **Review**
   + lattices, meets, joins

2. **Equivalence relations**
   + definition
   + equivalence <-> partition correspondence
   + examples

3. **Distributive lattices**
   + definition
   + examples and nonexamples
   + exercise: show one distributive law is sufficient; it's dual is equivalent.

4. **Modular lattices**
   + some parts of characterizations distrib ⇔ the two majorities are equal ⇔ no 𝑀₃, 𝑁₅; or modular ⇔ no 𝑁₅.

Ref: Bergman 2.1, 2.2, 2.3  
[lecture notes](https://www2.karlin.mff.cuni.cz/~barto/UA/UA_Lecture_Notes_02.pdf), 
[practical notes](https://gitlab.com/universalalgebra/charlesuniversity/nmag405/-/blob/master/notes/practical/NMAG405Practical02.pdf)
 
--------------------------------------

### 1. Oct 8

1. **Partial orders and posets**
   + properties of binary relations: reflexivity, symmetry, antisymmetry, transitivity
   + definitions: preorder, partial order
   + example of a preorder from propositional logic.

2. **Hasse diagrams**
   + examples

3. **Semigroups, semilattices**
   + properties of binary operations: idempotence, associativity, commutativity
   + definition of semigroup and semilattice (= commutative, idempotent semigroup)
   + definition of meet (=glb) and join (=lub); example

4. **Lattices**
   + definition (meet + join semilattice operations, plus absorptive laws)
   + lattice <-> lattice order correspondence (x ≤ y iff x ∧ y = x iff x ∨ y = y)
   + examples and non-examples of lattices, semilattices, posets
   + antichain example

Ref: Bergman 1.1, 1.2  
[Lecture notes](https://www2.karlin.mff.cuni.cz/~barto/UA/UA_Lecture_Notes_01.pdf), 
[practical notes](https://gitlab.com/universalalgebra/charlesuniversity/nmag405/-/blob/master/notes/practical/NMAG405Practical01.pdf)

---------------------------------------------------
